/* debug.c
 * 
 * any debug routines go here
 *
 */

#include <strings.h>
#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <sys/types.h>
#include "extern.h"
#include "defines.h"

int print_debug(int level, char *fmt, ...) {
	
	int d;
	char c, *p, *s;
	char *t, *str, *memp;
	va_list args;

	memp=str=(char *)strdup(fmt);
	if (debug>=level) {
		printf("Debug[%d]: ", level);
		va_start(args, fmt);
		while(*str) {
			t=str;
			t=(char *)strchr(t, '%');
			if (!t) break;
			*t='\0';
			if (str) printf(str);
			t++;
			str=t;
			switch(*str++) {
				case 's':
					s = va_arg(args, char *);
					printf("%s", s);
					break;
				case 'd':
					d = va_arg(args, int);
					printf("%d", d);
					break;
				case 'c':
					c = (char) va_arg(args, int);
					printf("%c", c);
					break;
				case 'p':
					s = va_arg(args, char *);
					printf("%p", s);
					break;
			}
			va_end(args);
		}
		if (str) printf(str);
		// printf("\n");
	}
	free(memp);
}
